// (C) Copyright 2015 Moodle Pty Ltd.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

import { InstallReferrer } from '../src/ts/plugins/InstallReferrer';
import { SecureStorage as SecureStorageImpl } from '../src/ts/plugins/SecureStorage';
import { Diagnostic } from '../src/ts/plugins/Diagnostic';

declare global {

    interface MoodleAppPlugins {
        secureStorage: SecureStorageImpl;
        installReferrer: InstallReferrer;
        diagnostic: Diagnostic;
    }

    interface Cordova {
        MoodleApp: MoodleAppPlugins; // eslint-disable-line @typescript-eslint/naming-convention
    }

}

export type SecureStorage = InstanceType<typeof SecureStorageImpl>;
