// (C) Copyright 2015 Moodle Pty Ltd.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

import { NgModule } from '@angular/core';
import { CoreSharedModule } from '@/core/shared.module';
import { CoreCommentsComponentsModule } from '@features/comments/components/components.module';
import { CoreRatingComponentsModule } from '@features/rating/components/components.module';
import { CoreTagComponentsModule } from '@features/tag/components/components.module';
import { RouterModule, Routes } from '@angular/router';
import { AddonModGlossaryEntryPage } from '@addons/mod/glossary/pages/entry/entry';

const routes: Routes = [{
    path: '',
    component: AddonModGlossaryEntryPage,
}];

@NgModule({
    declarations: [
        AddonModGlossaryEntryPage,
    ],
    imports: [
        RouterModule.forChild(routes),
        CoreSharedModule,
        CoreCommentsComponentsModule,
        CoreRatingComponentsModule,
        CoreTagComponentsModule,
    ],
})
export default class AddonModGlossaryEntryLazyModule {}
